
/*
 * $Id: PolySrv.cc,v 1.5.2.2 1999/10/22 21:41:46 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include <iostream.h>
#include <iomanip.h>

#include "Clock.h"
#include "Server.h"
#include "StatPhaseMgr.h"
#include "Rnd.h"
#include "OLog.h"
#include "LogComment.h"
#include "SharedOpts.h"
#include "SrvOpts.h"
#include "ServerSym.h"
#include "PolySrv.h"

#include "gadgets.h"
#include "shutdown.h"
#include "globals.h"


PolySrv::PolySrv() {
	theAgentType = "Server";
}

Agent *PolySrv::makeAgent(const AgentCfg &cfg) {
	Assert(cfg.sym);
	
	const ServerSym *scfg = &(const ServerSym&)cfg.sym->cast("Server");
	Server *server = new Server();
	server->configure(scfg, *cfg.host, agentMustBind);
	
	return server;
}

void PolySrv::configure() {
	PolyApp::configure();
}

void PolySrv::getOpts(Array<OptGrp*> &opts) {
	PolyApp::getOpts(opts);
	opts.append(&TheSrvOpts);
}

void PolySrv::logState(OLog &log) {
	PolyApp::logState(log);
}


int main(int argc, char *argv[]) {
	PolySrv app;
	return app.run(argc, argv);
}
