
/*
 * $Id: CltCfg.h,v 1.1.2.1 1999/11/06 00:35:12 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CLIENT_CONFIGURATION_H
#define PG_CLIENT_CONFIGURATION_H

class RndDistr;
class PopModel;
class RobotSym;

class CltCfg {
	public:
		CltCfg();
		void configure(const RobotSym *rs);

	public:
		RndDistr *theOriginSel;    // selects origin hosts (set by Client)
		PopModel *thePopModel;     // popularity model to select old oids
		double thePublicRatio;     // how often to request a "public" object
		double theRecurRatio;      // how often to re-visit an old object
		double theEmbedRecurRatio; // how often to re-visit an old embedded obj

		Time theLaunchWin;
		int theWaitXactLmt;        // limit on the number of postponed requests

		int theSrvCount;           // number of servers (set by Client)

		bool genUniqUrls;          // each generated URL must be unique
};

#endif
