
/*
 * $Id: CmdLine.h,v 1.2 1999/09/17 23:54:36 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_COMMAND_LINE_H
#define PG_COMMAND_LINE_H

#include "String.h"
#include "Array.h"

class Opt;
class OptGrp;

// command line parser
class CmdLine {
	public:
		CmdLine();
		virtual ~CmdLine();

		void configure(const Array<OptGrp*> &groups);
		bool parse(int argc, char *argv[]);

		void usage(ostream &os) const;
		void report(ostream &os) const; // both raw and parsed
		void reportRaw(ostream &os) const;
		void reportParsed(ostream &os) const;

	protected:
		// parse one option at a time
		bool parse(const char *name, const char *val);

	protected:
		Array<char *> theArgs;
		Array<Opt *> theOpts;
		OptGrp *theAnonymParser; // group to use for anonymous options

		String thePrgName;   // program name (argv[0])
};

#endif
