
/*
 * $Id: LogIter.h,v 1.1.2.1 1999/12/19 06:31:32 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_LOG_ITERATOR_H
#define PG_LOG_ITERATOR_H

#include "ILog.h"

// iterates ILog
class LogIter {
	public:
		LogIter(ILog *aLog = 0);

		LogIter &start(ILog *aLog);

		bool eof() const;
		operator void *() const;
		LogIter &operator ++();

		const LogEntryPx &operator *();  // current position

	protected:
		void sync();

	protected:
		ILog *theLog;
		LogEntryPx thePx;
};

#endif
