
/*
 * $Id: OidCache.h,v 1.1.2.1 1999/10/13 17:27:53 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_OID_CACHE_H
#define PG_OID_CACHE_H

#include "Ring.h"
#include "Array.h"

class OidRec;

// an imprecise cache for object ids
class OidCache {
	public:
		OidCache(int aCapacity = 0);

		void capacity(int aCap);

		bool hasOid(const OidRec &oidr) const;
		void putOid(const OidRec &oidr);

	protected:
		int hash(const OidRec &oidr) const;
		void purgeOne();

	protected:
		typedef unsigned short Idx;     // index into a hash
		typedef unsigned char HashItem; // number of collisions
		Ring<Idx> theHistory;          
		Array<HashItem> theHash;
};

#endif
