
/*
 * $Id: StatIntvl.h,v 1.4.6.1 1999/11/29 00:10:25 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_STAT_INTERVAL_H
#define PG_STAT_INTERVAL_H

#include "AlarmClock.h"
#include "StatIntvlRec.h"
#include "polyBcastChannels.h"

class Connection;
class Xaction;

// collects and aggregates simple stats in StatIntvlRec
// base class for StatCycle and StatPhase
class StatIntvl: public AlarmUser, public BcastRcver {
	public:
		StatIntvl(StatIntvlRec &aRec);
		virtual ~StatIntvl();

		virtual void noteConnEvent(BcastChannel *ch, const Connection *c);
		virtual void noteXactEvent(BcastChannel *ch, const Xaction *x);

		void noteFileScanEnd(int scannedFiles);

	protected:
		void report(ostream &os) const;

	protected:
		Time theIntvlStart;

	private:
		StatIntvlRec &theRec; 

};

#endif
