
/*
 * $Id: rndDistrStat.h,v 1.1 1999/09/28 05:14:02 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_RANDOM_DISTRIBUTION_STATISTICS_H
#define PG_RANDOM_DISTRIBUTION_STATISTICS_H

#include "AggrStat.h"

// some distributions do not have a known mean/dev or we do not know how to
// calculate them; this function samples a given [arbitrary] distribution.

// note1: this function is slow.

// note2: AggrStat operates on integers, RndDistr::trial() returns doubles;
// if needed, use scale parameter, but do not forget to sacle back!

extern AggrStat RndDistrStat(RndDistr *d, double scale = 1, int sampleSize = 10000);

#endif
