
/*
 * $Id: StatsSampleSym.cc,v 1.1.2.1 1999/10/22 23:30:08 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "PglRec.h"
#include "StatsSampleSym.h"


StatsSampleSym::StatsSampleSym(): RecSym("StatsSample", new PglRec) {
	theRec->bAdd("string", "name", 0);
	theRec->bAdd("time", "start", 0);
	theRec->bAdd("int", "capacity", 0);
}

StatsSampleSym::StatsSampleSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool StatsSampleSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "StatsSample";
}

SynSym *StatsSampleSym::clone(const String &type) const {
	if (isA(type))
		return new StatsSampleSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}

String StatsSampleSym::name() const {
	return getString("name");
}

Time StatsSampleSym::start() const {
	return getTime("start");
}

bool StatsSampleSym::capacity(int &cap) const {
	return getInt("capacity", cap);
}
