
/*
 * $Id: PglRateSym.h,v 1.4 1999/09/07 17:48:07 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_RATE_SYMBOL_H
#define PGL_RATE_SYMBOL_H

#include "Time.h"
#include "PglExprSym.h"

class TimeSym;
class NumSym;

// rate [objects/time]

class RateSym: public ExpressionSym {
	public:
		RateSym(double aCount, Time AnInterval);
		RateSym(double aVal);

		double val() const; // [obj/sec]
		void val(double aVal); // [obj/sec]
		//void val(double aCount, Time AnInterval);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		ExpressionSym *operRR(const String &op, RateSym *rs, const SynSym &s) const;
		ExpressionSym *operRT(const String &op, TimeSym *ts, const SynSym &s) const;
		ExpressionSym *operRN(const String &op, NumSym *ns, const SynSym &s) const;

	protected:
		double theCount;
		Time theInterval;
};

#endif
