
/*
 * $Id: PhaseSym.h,v 1.2.6.1 1999/11/24 21:03:00 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_PHASE_SYMBOL_H
#define PGL_PHASE_SYMBOL_H

#include "String.h"
#include "PglRecSym.h"

class GoalSym;

// base class for robot and server symbols
class PhaseSym: public RecSym {
	public:
		PhaseSym();
		PhaseSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		void name(const String &aName);

		String name() const;
		GoalSym *goal() const;
		bool recurFactor(double &rf) const;
		bool loadFactorBeg(double &f) const;
		bool loadFactorEnd(double &f) const;
		bool logStats(bool &ls) const;
};

#endif
