
/*
 * $Id: StatsSampleSym.h,v 1.1.2.1 1999/10/22 23:30:11 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_STATS_SAMPLE_SYMBOL_H
#define PGL_STATS_SAMPLE_SYMBOL_H

#include "String.h"
#include "PglRecSym.h"

class StatsSampleCfg;

// describes properties of a single stats sample
class StatsSampleSym: public RecSym {
	public:
		StatsSampleSym();
		StatsSampleSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		String name() const;
		Time start() const;
		bool capacity(int &cap) const;
};

#endif
