
/*
 * $Id: polyBcastChannels.cc,v 1.5.4.3 1999/12/27 00:18:08 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "polyBcastChannels.h"

BcastChannel *TheWaitBegChannel = 0;
BcastChannel *TheWaitEndChannel = 0;

BcastChannel *TheConnOpenChannel = 0;
BcastChannel *TheConnEstChannel = 0;
BcastChannel *TheConnCloseChannel = 0;

BcastChannel *TheXactBegChannel = 0;
BcastChannel *TheXactEndChannel = 0;
BcastChannel *TheXactErrChannel = 0;

BcastChannel *TheErrChannel = 0;
BcastChannel *TheInfoChannel = 0;

BcastChannel *TheLogCfgChannel = 0;
BcastChannel *TheLogStateChannel = 0;

BcastChannel *ThePhasesEndChannel = 0;


/* initialization */

int PolyBcastChannelsInit::TheUseCount = 0;

void PolyBcastChannelsInit::init() {
	TheWaitBegChannel = new BcastChannel("wait_beg");
	TheWaitEndChannel = new BcastChannel("wait_end");

	TheConnOpenChannel = new BcastChannel("conn_open");
	TheConnEstChannel = new BcastChannel("conn_est");
	TheConnCloseChannel = new BcastChannel("conn_close");

	TheXactBegChannel = new BcastChannel("xact_beg");
	TheXactEndChannel = new BcastChannel("xact_end");
	TheXactErrChannel = new BcastChannel("xact_err");

	TheErrChannel = new BcastChannel("error");
	TheInfoChannel = new BcastChannel("info");

	TheLogCfgChannel = new BcastChannel("log_cfg");
	TheLogStateChannel = new BcastChannel("log_state");

	ThePhasesEndChannel = new BcastChannel("shutdown");
}

void PolyBcastChannelsInit::clean() {
	delete TheWaitBegChannel; TheWaitBegChannel = 0;
	delete TheWaitEndChannel; TheWaitEndChannel = 0;

	delete TheConnOpenChannel; TheConnOpenChannel = 0;
	delete TheConnEstChannel; TheConnEstChannel = 0;
	delete TheConnCloseChannel; TheConnCloseChannel = 0;

	delete TheXactBegChannel; TheXactBegChannel = 0;
	delete TheXactEndChannel; TheXactEndChannel = 0;
	delete TheXactErrChannel; TheXactErrChannel = 0;

	delete TheErrChannel; TheErrChannel = 0;
	delete TheInfoChannel; TheInfoChannel = 0;

	delete TheLogCfgChannel; TheLogCfgChannel = 0;
	delete TheLogStateChannel; TheLogStateChannel = 0;

	delete ThePhasesEndChannel; ThePhasesEndChannel = 0;
}

