
/*
 * $Id: polyErrors.cc,v 1.13.2.4 2000/01/11 23:58:23 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "String.h"
#include "ErrorStrTbl.h"
#include "polyErrors.h"

struct PolyErrorStrTbl: public ErrorStrTbl {
	PolyErrorStrTbl();
};

PolyErrorStrTbl ThePolyErrorStrTbl;

PolyErrorStrTbl::PolyErrorStrTbl() {
	str(errForeignReq)    = "foreign request";
	str(errForeignRep)    = "foreign reply";
	str(errPrematureEof)  = "premature end of msg body";
	str(errPrematureEoh)  = "premature end of msg header";
	str(errExtraRepData)  = "extra reply data";
	str(errNoHdrClose)    = "connection closed before sending headers";
	str(errNoCLen)        = "no Content-Length header";
	str(errHugeHdr)       = "HTTP header is too big";
	str(errUnchbHit)      = "hit on uncachable object";
	str(err1UseHit)       = "hit on first request to an object";
	str(errZeroFDLimit)   = "zero filedescriptor limit?!";
	str(errChbChange)     = "cachability status changed";
	str(errFalseHit)      = "false hit";
	str(errServerGone)    = "server had to terminate";
	str(errLogBufFull)    = "log buffer is full";
	str(errUnclaimOid)    = "a server-advertised oid has not been requested for a while";
	str(errUnsolicOid)    = "a non-server-advertised oid has been requested";
	str(errNoNewOids)     = "client ran out of new public oids";
	str(errFidFlood)      = "cannot send failed oids to servers fast enough";
	str(errNidReqFlood)   = "server received too many requests for new oids";
	str(errNidRepFlood)   = "client received too many new oids";
	str(errNidMapLimit)   = "server new oid map cannot grow any more";
	str(errSrvChangedWid) = "client discovered server world id change";
	str(errWrongContentId)= "client requested an object of unknown [content] type";
	str(errForeignTag)    = "foregn content <tag>";
	str(errMalformedTag)  = "malformed content <tag>";
	str(errOpenTag)       = "open content <tag"; // vs. unbalanced
	str(errTooManyWaitXact)= "too many postponed xactions";
	str(errTimingDrift)   = "internal timers may be getting behind";

	str(errOther) = "unclassified error";

	// check that all are defined
	for (int i = errStart+1; i < errEnd; ++i)
		Assert(item(i) && *item(i));
}

const ErrorStrTbl *polyErrorStrTbl() {
	return &ThePolyErrorStrTbl;	
}
